import pytest
from a9 import *


@pytest.fixture(scope="session", autouse=True)
def fsa():
    m = FSA(deterministic=True)

    words = set()
    with open("lexicon.txt", 'rt', encoding="utf8") as f:
        for w in f:
            words.add(w.strip())
    m.insert_words(words)

    return m, words


def test_insert_words(fsa):
    m, lexicon = fsa

    for w in lexicon:
        assert m.recognize(w)
    assert not m.recognize("works")
    assert not m.recognize("wors") and not m.recognize("wals")


def test_minimized(fsa):
    m, _ = fsa
    prev_states = len(m._states)
    m.minimize()

    assert prev_states > len(m._states)
    assert len(m.accepting) == 2
    assert not m.recognize("wal") and m.recognize("walls") and m.recognize("work")
